;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Downfall.... brought to you by REBOOT!
;;
;; (c) 2011 Reboot
;;
;; All Rights Reserved
;;
;; Assembles and links with SMAC and SLN by SubQMod
;; 
;;





                .include    "jaguar.inc"
                .text

objs			equ 	32+32						; maximum number of objects in list

ob_list			equ		$200000-$4000				; address of list (shadow)
ob_list1		equ		ob_list+$2000				; address of read list

lines_per_level	equ		64
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Code entrypoint
;;

top_of_the_code:
				lea		$200000-4,a7

				moveq	#0,d0						;
				move.l	d0,$f00000+$1a148			; L_I2S
				move.l	d0,$f00000+$1a14c			; R_I2S
				move.l	d0,$f00000+$2114			; G_CTRL 
				move.l	d0,$f00000+$1a114			; D_CTRL
				move.l	d0,$f00000+$2100			; G_FLAGS
				move.l	d0,$f00000+$1a100			; D_FLAGS
				move.l	#$00070007,$f00000+$1a10c	; D_END
				move.l	#$00070007,$f00000+$210c	; G_END
;				bclr	#0,DIV_OFFSET				;
;				move.w	MEMCON1,d0					;
;				bset	#1,d0						;
;				bclr	#2,d0						; All this required for
;				bset	#3,d0						; the Jagware cart
;				bset	#4,d0						;
;				bclr	#7,d0						;
;				move.w	d0,MEMCON1					;
				
				lea		top_of_bss,a0				; clear BSS
				lea		_trashram,a1
clear:			clr.l	(a0)+
				cmp.l	a1,a0
				bne.s	clear

				jsr     musicplayer					; init music player
				move.l	#110,d0
                jsr     musicplayer+$14
                move.l	#190,d0
                jsr     musicplayer+$18				

				move.l	#'0000',mt_buffer
				move.l	#'1000',mt_buffer+4
				move.l	#1000,mt_buffer+8

				move.l #memory_track_work,work_area
				bsr		mt_init
				tst.l	mt_present
				bmi		.didnt_load
					
				lea		mt_buffer,a0
				lea		high_ascii,a1
				move.l	(a0)+,(a1)+					; load 1st half of ascii
				move.l	(a0)+,(a1)+					; load 2nd half of ascii
				move.l	(a0)+,(a1)+					; load highscore
				
.didnt_load:				
				
;
;				
;								 Varmod
;								 |	   0=CRY16 | 1=RGB24 | 2=DIRECT16 | 3=RGB16	
;								 |	   ||
; 								 |	   ||Vid enable
;								 |	   |||	
				move.w	#%0000011011000111,VMODE	; 320x256
				move.w	#$100,JOYSTICK				; turn off MUTE
                jsr     InitVideo               	; Setup our video registers.

				jsr     MakeObjectList          	; Create bit magled list for OP
				
                move.l  #VB_INTERUPT,LEVEL0     	; Install 68K LEVEL0 handler
                move.w  a_vde,d0                	; Must be ODD
                sub.w   #16,d0
                ori.w   #1,d0
                move.w  d0,VI

                move.w  #1,INT1                 	; Enable video interrupts
                and.w   #$f8ff,sr
			
				bsr		wait_frame
				bsr		set_title_list				; title splash				

				lea		reboot_bmp,a0				; convert logo
				lea		logo_jag,a1
				lea		temppal,a2
				moveq	#1,d5
				move.l	#320,d6
				move.l	#74,d7
				bsr		ConvertBMP	
				
				move.l	title_obj,a0				; position logo object
				move.l	#0,d0
				move.l	#80,d1
				jsr		setup_object_xy			
				
				move.l	#ob_list,d0					; set the object list pointer
				swap	d0
				move.l	d0,OLP

				tst.l	gorffound					; did we find ORF(tm) ? (Try it on PAL hahaha!)
				bmi		.gorf_cd					; branch if we did!
				
				move.l	#reboot_sam,a0				; rebooOOoooOOOoot!
				move.l	#reboot_end-reboot_sam,d0
				moveq	#3,d7
				bsr		do_sample
				bra		.cont
				
.gorf_cd:		move.l	#illegal_sam,a0				; Illegal aliens detected!
				move.l	#illegal_end-illegal_sam,d0
				moveq	#3,d7
				bsr		do_sample	

.cont:			move.l	#3*60,d6					; wait for sample to play
.hold:			bsr		wait_frame
				dbra	d6,.hold
				
				bsr		set_blank_list				; blank the screen

				bsr		convert_bmp					; convert the game gfx
				
				lea		music,a0					; init the music
				jsr		musicplayer+$4
				moveq	#4,d0						; set title music loop
				bsr		change_pattern

				move.l	score_obj,a0				; put the scoreboard onscreen
				move.l	#184,d0
				move.l	#20,d1
				jsr		setup_object_xy

				move.l	high_obj,a0					; put the highscore onscreen
				move.l	#8,d0
				move.l	#20,d1
				jsr		setup_object_xy
				
				lea		dist_ascii,a0				; draw initial scoreboard
				lea		score_jag,a1
				moveq	#7,d7
				bsr		do_numerals				
				
				lea		high_ascii,a0				; draw the hiscore
				lea		high_jag,a1
				moveq	#7,d7
				bsr		do_numerals
				bsr		replace_highscore			; align correctly
				
				bsr		set_game_list				; show the game screen
				
				tst.w	ntsc_flag					; PAL?
				bpl		first_time					; if no, skip
				
				lea		blocking_jag,a0				; clear the blockmask
				move.l	#((40*16)/4)-1,d7
.eraser:		clr.l	(a0)+
				dbra	d7,.eraser
				
				move.l	blocking_obj,a0				; and position it at the top
				move.l	#0,d0
				move.l	#0,d1						; yeah its lazy, and dirty code
				bsr		setup_object_xy				; but it works, so why stress?
				
				bra		first_time					; ain't game over now!
				
gameover:		move.l	player_obj,a0				; address of player object in list
				move.l	#400,d0						; get x
				move.l	#400,d1						; get y
				bsr		setup_object_xy				; update the list

				move.l	parachute_obj,a0			; address of parachute object in list
				move.l	#400,d0						
				move.l	#400,d1					
				bsr		setup_object_xy				; setup object
				
				move.l	#gameover_sam,a0			; game over sample
				move.l	#gameover_end-gameover_sam,d0
				moveq	#3,d7
				bsr		do_sample

				move.l	#240,d5						; wait for sample to play
.longpause:		bsr		wait_frame
				dbra	d5,.longpause
				
				tst.l	mt_present					; memory track present?
				bmi		first_time					; nope, skip
				
				tst.l	highscore					; did we get a highscore?
				bpl		first_time					; nope, skip
				
				lea		mt_buffer,a1
				lea		high_ascii,a0
				move.l	(a0)+,(a1)+					; save 1st half of ascii
				move.l	(a0)+,(a1)+					; save 2nd half of ascii
				move.l	(a0)+,(a1)+					; save highscore
				bsr		mt_save						; save to MemoryTrack
				
first_time:
				move.l	#-1,current_pri				; clear sample priority
				
				move.l	logo_obj,a0					; put title logo on screen
				move.l	#0,d0
				move.l	#48,d1
				jsr		setup_object_xy				

				move.l	#0,d0						; x=0
				move.l	#400,d1						; y=16
				move.l	screen_obj,a0				; address of screen object in list
				bsr		setup_object_xy				; update (d2=bitmap address)

				move.l	player_obj,a0				; address of player object in list
				move.l	#400,d0						; get x
				move.l	#400,d1						; get y
				bsr		setup_object_xy				; update the list
				
				move.l	#156,player_x				; setup initial player position
				move.l	#0,player_x+4				; fractional 
				move.l	#18,player_y			
				move.l	#0,player_y+4
				move.l	#0,player_x_adder			; fractional addition for inertia
				move.l	#0,player_y_adder
				
				move.l	#0,fruit_next				; reset the fruit pickups
				move.l	#-1,fruit_active
				move.l	#7,fruit_countdwn
				move.l	#0,fruit_x
				move.l	#400,fruit_y
				
				move.l	#3,jetpack_togo				; reset the jetpack
				move.l	#-1,jetpack_use
				move.l	#-1,jetpack_next
				move.l	#-1,jetpack_timer
				
				move.l	#-1,jumping_timer			; disable active jumping
				move.l	#-1,para_timer				; disable active parachute
				
				move.l	#1,_25hz					; set the 25hz flipflag
				move.l	#0,falling_offset			; man isnt falling
						
				move.l	#1,background_flag			; turn on background scrolling cheat
						
				move.l	fruit_obj,a0				; make sure theres no fruit
				move.l	fruit_x,d0					; on the screen
				move.l	fruit_y,d1
				bsr		setup_object_xy				

				move.l	#downfall,a0				; DOWNFALL! sample
				move.l	#downfall_end-downfall,d0
				moveq	#3,d7
				bsr		do_sample
				
				lea		screen,a0					; clear the screen data
				move.l	a0,a1
				add.l	#640*256*2,a1
.eraser:		clr.w	(a0)+
				cmp.l	a0,a1
				bne.s	.eraser
	
				move.l	#0,textblock_text			; intro text pointer
				move.l	#256,textblock_y			; intro text y-position
				move.l	#-1,textblock_dir			; -1 = going up!
				move.l	#100,textblock_count		; for 100 pixels till wrap
				move.l	#-1,textblock_hold			; don't hold :)
				bsr		redraw_titletext			; draw first block of text

;;
;; Title screen
;;
				
waitbutton:		bsr		wait_frame					; vsync
				bsr		title_writer
				jsr		readpad						; read jagpad
				jsr		handle_input				; analyze jagpad
				tst.w	dpad_b						; b?
				beq		waitbutton					; no, go around again

				move.l	textblock_obj,a0			; remove textblock
				move.l	#400,d0
				move.l	#400,d1
				jsr		setup_object_xy						
				
				move.l	#0,scroll_newwall			; new line of gfx every 8 scanlines
				move.l	#wall0_jag,scroll_ptr		; first walltype is "blank"
				move.l	#0,scroll_wallgap			; 9*8 lines between each new wall

				move.w	#'BA',last_wall
				
				lea		score_jag,a0				; clear the score
				move.l	#((80*16)/4)-1,d7			; (needs to be removed, as
.clrscore:		clr.l	(a0)+						;  leading zeros are skipped)
				dbra	d7,.clrscore
				
				move.l	#0,total_dist				; reset the score
				move.l	#'0000',dist_ascii	
				move.l	#'0000',dist_ascii+4
				move.w	#'00',dist_ascii-2	
				move.l	#1,highscore

				move.l	#5,talknow					; reset random speech counter 1
				move.l	#0,talkie_delay				; reset random speech counter 2
				
				lea		dist_ascii,a0				; draw initial scoreboard
				lea		score_jag,a1
				moveq	#7,d7
				bsr		do_numerals	

				move.l	#-1,jumping					; disable jumping
				
				move.l	#lines_per_level-1,line_counter	; reset the game
				move.l	#0,tileset
				move.l	#0,mapset
				
				move.l	logo_obj,a0					; move the logo off the screen
				move.l	#0,d0
				move.l	#480,d1
				jsr		setup_object_xy

				lea		wall0_jag,a0				; make sure the wall
				lea		wall1_jag,a1				; buffer is blank
.blank:			clr.w	(a0)+
				cmp.l	a0,a1
				bne.s	.blank
				
				move.l	#64,d7						; have some starting
initloop:		move.l	d7,-(a7)					; platforms on screen
				bsr		wait_frame					; so you don't just fall
				bsr		scroll_screen				; straight to your death
				move.l	(a7)+,d7
				dbra	d7,initloop

mainloop:		bsr		wait_frame					; vsync

				jsr		readpad						; read jagpad
				jsr		handle_input				; analyze jagpad

				bsr		do_panels					; update scoreboard
				
				tst.w	dpad_number					; Toggle background movement
				bne 	.no_pad0
				neg.l	background_flag			
.no_pad0:

				move.l	player_y_adder,d0			; player y height
				add.l	d0,player_y+2				; add vertical speed

				cmp.l	#240,player_y				; are we at the bottom of the screen?
				bgt		gameover					; GAME OVER PLAYER ONE
				cmp.l	#17,player_y				; are we at the top of the screen?
				blt		gameover					; GAME OVER PLAYER ONE
				
				moveq	#0,d7						; pad movement flag (0=no movement)

				move.l	#-1,falling					; man falling flag (-1 = falling)

				tst.w	dpad_left					; going left?
				beq.s	.not_left
				
.left:			move.l	player_obj,a1				; get address of player object
				bsr		flipset						; set mirror flag in object list
				move.l	#-1,at_stop					; set "he's moving" flag
				
				moveq	#1,d7						; moving flag direction
				move.l	d7,direction				; set direction (used for object update)

				cmp.w	#-3,player_x_adder			; at max left velocity?
				beq		.left_right_done			; then we're done
				sub.l	#$2000,player_x_adder		; incrememt left velocity
				bra		.left_right_done			; we're done
				
.not_left:		tst.w	dpad_right					; going right?
				beq.s	.left_right_done
				
.right:			move.l	player_obj,a1				; get address of player object
				bsr		flipclr						; set unmirrored in object list
				move.l	#-1,at_stop					; set "he's moving" flag
				
				moveq	#2,d7						; moving flag direction
				move.l	d7,direction				; set direction (used for object update)

				cmp.w	#3,player_x_adder			; at max right velocity?
				beq		.left_right_done			; then we're done
				add.l	#$2000,player_x_adder		; increment right velocity

.left_right_done:
				tst.l	_25hz						; flip 25hz flag
				bpl		.noslow						; only do slowdown every other frame

				tst.l	d7							; and only if we're actually moving
				bne.s	.noslow						; otherwise skip

				tst.l	player_x_adder				; are we at stop?
				beq		.stopped					; then we're done
				bmi		.adder						; if -nve then we need to increment to slow
.subber:		sub.l	#$2000,player_x_adder		; decrement to slow (was moving right)
				bra		.noslow
.adder:			add.l	#$2000,player_x_adder		; increment to slow (was moving left)
				bra		.noslow
.stopped:		move.l	#1,at_stop					; set stopped flag (used for object update)
.noslow:
				bsr		scroll_screen				; scroll the screen
				bsr		process_fruit

.notfaster:		moveq	#0,d6						; thrust flag (off)
				
				tst.l	jumping						; jumping?
				bmi		.notjump					; nope!
				subq.l	#1,jumping					; dec jump counter
				bra		.is_jumping					; yes, we're jumping
		
.notjump:		tst.l	jetpack_timer				; jetpack active?
				bmi		.dont_have_jetpack			; no, then we're done here
								
				move.l	top_of_screen,a0			; get the top of the visible screen
				add.l	#14,a0						; sprite is 16px wide, 16bpp, so +14 = centre 2 pixels
				add.l	player_x,a0					; add x position
				add.l	player_x,a0					; add again (2 byte=1 pixel, 16bpp remember?)
				move.l	player_y,d7					; get y position
				sub.l	#16,d7						; subtract 2 (sprite not full height)
				mulu	#640,d7						; multiply by scanline width (320px=640 bytes)
				add.l	d7,a0						; add
				
				move.l	-648(a0),d3					; check the pixels above the player
				add.l	-644(a0),d3					; by adding them
				add.l	-640(a0),d3
				add.l	-636(a0),d3					; if any are <>0
				add.l	-632(a0),d3
				add.l	-8(a0),d3
				add.l	-4(a0),d3
				add.l	(a0),d3
				add.l	4(a0),d3
				add.l	8(a0),d3					; then D3<>0 at the end
				
				tst.l	d3							; anything above us?
				bne		.kill_thrust				; if so, can't thrust

				tst.w	dpad_b						; button pressed?
				beq		.dont_have_jetpack			; if no, then we're done
				
.is_jumping:	cmp.w	#-5,player_y_adder			; at max vertical velocity?
				beq.s	.notslower					; if yes, don't go faster
				sub.l	#$8000,player_y_adder		; go faster!
.notslower:		moveq	#-1,d6						; thrusting flag (on)
				bra		.dont_have_jetpack
				
.kill_thrust:	clr.l	player_y_adder				; we hit a wall, so can't go up
				add.l	#1,player_y					; must go down 1 line (wall drag)
				clr.w	player_y+4					; clear fractional addition
				
.dont_have_jetpack:
				move.l	top_of_screen,a0			; get the top of the visible screen
				add.l	#14,a0						; sprite is 16px wide, 16bpp, so +14 = centre 2 pixels
				add.l	player_x,a0					; add x position
				add.l	player_x,a0					; add again (2 byte=1 pixel, 16bpp remember?)
				move.l	player_y,d7					; get y position
				sub.l	#2,d7						; subtract 2 (sprite not full height)
				mulu	#640,d7						; multiply by scanline width (320px=640 bytes)
				add.l	d7,a0						; add

				tst.l	640(a0)						; check +2 line below
				bne		.on_wall_1down				; if anything, we're on a wall
				tst.l	(a0)						; check +1 line below
				bne		.on_wall_1down				; if anything, we're on a wall
				bra		.must_fall					; else we're falling!

.on_wall_2down:	sub.l	#1,player_y					; correct for "in wall"
.on_wall_1down:	sub.l	#1,player_y					; move with wall

				tst.l	jumping_timer				; jump enabled?
				bmi		.not_jumping				; nope, we're done
				tst.w	dpad_b						; B on a wall? (jump)
				beq		.not_jumping
				move.l	#4,jumping					; jump counter
				move.w	#-2,player_y_adder			; clear vertical inertia

.not_jumping:	tst.l	d6							; thrusting?
				bpl		.normal_wall				; if no, then its just a wall!
				move.w	#-2,player_y_adder			; bounce up off wall!
				bra		.skipset

.normal_wall:	move.w	#-1,player_y_adder			; move up with wall
.skipset:		clr.w	player_y+4					; clear fractional addition

				move.l	#-1,jetpack_use				; jetpack in use flag
				move.l	#1,falling					; falling flag
				bra		.drop_done
			
.must_fall:		
				moveq	#2,d7						; max fall speed
				tst.l	para_timer
				bmi		.drop_normally		
				moveq	#1,d7						; max fall speed with parachute

.drop_normally:	cmp.w	player_y_adder,d7			; at max drop speed?
				ble		.drop_done					; if yes, we're done
				add.l	#$4000,player_y_adder		; else fall faster!
			
.drop_done:		subq.l	#1,anim_delay				; animation delay counter
				bpl.s	.nowrap						; not time for next frame, jump over
				move.l	#3,anim_delay				; reset delay counter
				
				eor.l	#32*16,falling_offset		; 2 frames for falling, so toggle offset to the other one
				
				subq.l	#1,player_frame				; get next player frame
				bpl.s	.nowrap						; if no wrap, skip
				move.l	#7,player_frame				; else reset frame pointer
.nowrap:		move.l	player_frame,d2				; store current frame
				lsl.l	#4,d2						; multiply by (32*16)
				lsl.l	#5,d2						; ...very quickly  (32*16=512=shift left 9 times)
				add.l	#player_jag,d2				; add the sprite gfx base to get correct frame
				
				tst.l	at_stop						; are we moving?
				bmi.s	.moving						; no, so keep going
				move.l	#player_jag,d2				; reset to frame 0 (standing still)
.moving:		cmp.w	#2,player_y_adder			; falling at fastest speed?
				bne		.notfalling					; no, skip over... else!!!
				move.l	#player_jag+(12*(32*16)),d2	; reset to falling frame 0
				add.l	falling_offset,d2			; and add the falling frame offset from above

.notfalling:	tst.l	para_timer					; parachute active?
				bmi.s	.no_para					; nope, skip over
				subq.l	#1,para_timer				; reduce use timer
.no_para:		tst.l	jumping_timer				; jump active?
				bmi.s	.no_jumping					; nope, skip over
				subq.l	#1,jumping_timer			; reduce use timer
				
.no_jumping:	tst.l	jetpack_timer				; jetpack active?
				bmi.s	.no_jetpack					; nope, skip over
				subq.l	#1,jetpack_timer			; reduce use timer
				move.l	#player_jag+(8*(32*16)),d2	; set jetpack frame
				subq.l	#1,jetpack_frame
				bpl.s	.nowrap_jet
				move.l	#3,jetpack_frame
.nowrap_jet:	move.l	jetpack_frame,d0
				lsl.l	#4,d0
				lsl.l	#5,d0
				add.l	d0,d2						; frame to use
				
.no_jetpack:	move.l	player_x_adder,d0			; get x-fraction
				add.l	d0,player_x+2				; add it to x-position (with overflow)

				move.l	player_obj,a0				; address of player object in list

				cmp.w	#2,player_x+2				; gone off left?
				bgt.s	.ok_l
				clr.l	player_x_adder				; yes, so set to far left
				move.l	#2,player_x
				bra.s	.do_update
.ok_l:			cmp.w	#303,player_x+2				; gone off right?
				blt		.do_update
				clr.l	player_x_adder				; yes, so set to far right
				move.l	#303,player_x
.do_update:		move.l	player_x,d0					; get x
				move.l	player_y,d1					; get y

				move.l	d0,-(a7)					; SAVE player x
				cmp.l	#1,direction				; is object mirrored?
				bne.s	.setobj						; no, so we're done
				add.l	#16,d0						; add 16 to x-position (OL mirrors from opposite side)
.setobj:		move.l	d1,-(a7)					; SAVE player y
				bsr		setup_object_xyg			; update the list

				move.l	(a7)+,d1					; LOAD player y
				move.l	(a7)+,d0					; LOAD player x
				move.l	parachute_obj,a0			; address of parachute object in list
				tst.l	para_timer					; is parachute active?
				bpl.s	.do_chute					; if yes, skip over
				add.l	#400,d1						; no, so add 400 to y (offscreen)
.do_chute:		sub.l	#10,d1						; subtract 10 from y (chute above player)
				bsr		setup_object_xy				; setup object
			
				cmp.l	#2*60,jumping_timer
				beq.s	.do_banko
				
				cmp.l	#2*60,para_timer
				beq.s	.do_banko
			
				cmp.l	#2*60,jetpack_timer			; jetpack about to run out?
				bne		mainloop

.do_banko:		move.l	#banko,a0					; BANKOWANEGO!
				move.l	#banko_end-banko,d0
				moveq	#2,d7
				bsr		do_sample

				bra		mainloop					; and around we go :-)

talkie_delay:		dc.l	0
talknow:			dc.l	0
talklast:			dc.l	-1
line_counter:		dc.l	31
tileset:			dc.l	0
mapset:				dc.l	0
last_wall:			dc.w	0,0						; extra word for long align (jaguar thing)
top_of_screen:		dc.l	0						; address for 1st visible line on screen
scroll_newwall:		dc.l	7
scroll_ptr:			dc.l	wall0_jag
scroll_wallgap:		dc.l	8
screen_offset:		dc.l	0
wall_ptrs:			dc.l	wall1_jag
					dc.l	wall2_jag
					dc.l	wall3_jag
					dc.l	wall4_jag

;;
;; The "screen" is a window into an area of memory twice as tall as the screen height.
;; The physical screen is 256 lines high, the screen buffer is 512 lines high, we only ever see 256 lines of it.
;; The top pointer is moved down the screen until it gets to line 256, at which point it is reset to line 0.
;; This gives us a continuous scroll, however we have to make sure both the "top" and "bottom" screens are kept identical so
;; that when the flip occurs we cant see it.
;;

wall_rnd:		dc.l	0
wall_random:	dc.l	0
					
scroll_screen:	move.l	scroll_ptr,a0				; pointer to gfx to draw at bottom of screen
				move.l	screen_offset,a1			; offset into scroll window
				add.l	#screen,a1					; add the screenbase
				add.l	#255*640,a1					; take us to the bottom of screen 1
				move.l	a1,a2						; copy this
				sub.l	#256*640,a2					; take us to the bottom of screen 2
				move.l	#(640/4)-1,d7				; draw 1 scanline of data
.draw1line:		move.l	(a0),(a1)+					; draw to screen one
				move.l	(a0)+,(a2)+					; draw to screen two
				dbra	d7,.draw1line				; repeat for all of line
				move.l	a0,scroll_ptr				; and store pointer for next line
				
				sub.l	#1,scroll_newwall			; time for a new pointer to the next 8 lines of gfx?
				bpl		.not_new_row				; no, then we're done
				move.l	#7,scroll_newwall 			; here every 8 lines
				
				move.l	#wall0_jag,scroll_ptr		; set pointer to blank line
				sub.l	#1,scroll_wallgap			; gap between platforms... time for another one?
				bpl		.draw_blank_line			; no, then we're done
				move.l	#8,scroll_wallgap			; reset counter
	
				bsr		new_fruit
				
				subq.l	#1,line_counter				; time to change levels?
				bpl		.same_set
				move.l	#lines_per_level-1,line_counter	; reset level counter
				
				cmp.l	#7,tileset					; at tileset #8 ?
				bne		.no_tilewrap
				move.l	#-1,tileset					; reset it ready for the add
.no_tilewrap:	add.l	#1,tileset					; next tileset
				
				cmp.l	#7,mapset					; at highest mapset?
				beq		.same_set					; yes, stay on this mapset
				add.l	#1,mapset					; next mapset
.same_set:				
.draw_new_wall:
				move.l	mapset,d0					; get mapset
				asl.l	#2,d0						; *4 longword lookup
				lea		mapset_list,a6				; table to pointers
				move.l	(a6,d0.w),a6				; PLATFORM DATA

				move.l	wall_rnd,d7					; (0-31)

				cmp.w	last_wall,d7				; same as previous line?
				bne.s	.not_duped					; no, so skip
				addq.w	#1,d7						; add 1
				and.w	#%11111,d7					; and mask back to 0-31
.not_duped:		move.w	d7,last_wall				; store current line type
				mulu	#20,d7						; *20 for offset into block
				add.l	d7,a6						; pointer to PLATFORM DATA

				move.l	tileset,d7					; get tileset
				asl.l	#2,d7						; *4 longword lookup
				lea		tileset_list,a5				; table to tilesets
				move.l	(a5,d7.w),a5				; BLOCK data

				lea		wall0_jag,a0				; DESTINATION buffer
				move.l	#19,d7						; 20 sets of 2 chars = 40 chars = 640 bytes
.draw:			moveq	#0,d0
				moveq	#0,d1
				move.b	(a6)+,d0					; get 2 pixels
				move.b	d0,d1
				asr.w	#4,d0						; d0=left hand nybble
				and.w	#%1111,d1					; d1=right hand nybble
				
				asl.w	#4,d0						; *16 = 8 pixels
				asl.w	#4,d1						; *16 = 8 pixels
				
				move.l	a5,a3						; reset gfx pointer
				move.l	a5,a4						; reset gfx pointer 
				
				add.l	d0,a3						; add for left pixel
				add.l	d1,a4						; add for right pixel
				
				move.l	a0,a1						; write address
				
				moveq	#7,d6
.char:			movem.l	(a3),d0-d3					; 16 bytes = 8 pixels
				movem.l	d0-d3,(a1)					; output
				movem.l	(a4),d0-d3					; ...get 8 pixels
				movem.l	d0-d3,16(a1)				; ...output 8 pixels
				lea		64(a3),a3					; drop down 1 line
				lea		64(a4),a4					; drop down 1 line
				lea		640(a1),a1					; drop down 1 line
				dbra	d6,.char					; repeat for 8 lines
				lea		32(a0),a0					; move over 16 pixels
				
				dbra	d7,.draw					; repeat for line of wall
		
				bra		.not_new_row
				
.draw_blank_line:
				lea		wall0_jag,a0				; just clear the entire
				move.l	#((640*8)/4)-1,d7			; buffer, as we're on
.blankline:		clr.l	(a0)+						; a blank line
				dbra	d7,.blankline

				cmp.l	#7,scroll_wallgap			; half way :)
				bne.s	.no_random_talk
				
				subq.l	#1,talknow
				bpl.s	.no_random_talk
				move.l	#7,talknow					; new we are exactly half way between fruit
				
				subq.l	#1,talkie_delay
				bpl.s	.no_random_talk
				move.l	#3,talkie_delay
				
				move.l	wall_random,d1				; get a rnd number
				and.l	#$ffff,d1					; make it a word
				divu	#12,d1						; divide by 12
				swap.w	d1							; get remainder (0-11, or 12 variations)
				and.l	#$ffff,d1	
				
				cmp.l	talklast,d1
				bne.s	.sayit
				subq.l	#1,d1
				bpl.s	.sayit
				move.l	#11,d1
.sayit:			lea		random_samples,a0
				move.l	d1,talklast
				asl.l	#2,d1
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#0,d7
				bsr		do_sample
				
.no_random_talk:
				
.not_new_row:	move.l	screen_offset,d2			; current screen window offset into scroll area
				add.l	#640,d2						; add 1 scanline
				cmp.l	#640*256,d2					; end of screen?
				bne.s	.nowrap						; no, we're done here
				moveq	#0,d2						; reset pointer to 0 (top)
.nowrap:		move.l	d2,screen_offset			; store new pointer
				add.l	#screen,d2					; add address of screen

				move.l	d2,top_of_screen			; store top of screen address (for collision lookup above)
				
				move.l	#0,d0						; x=0
				move.l	#16,d1						; y=16
				move.l	screen_obj,a0				; address of screen object in list
				bsr		setup_object_xyg			; update (d2=bitmap address)
				
				rts				

;;
;; Pickup processing
;;
	
jumping:		dc.l	0
jumping_timer:	dc.l	0
para_timer:		dc.l	0
jetp_sample:	dc.l	0	
jumpp_sample:	dc.l	0
parap_sample:	dc.l	0
poulpe_sample:	dc.l	0
fruit_sample:	dc.l	0
fruit_next:		dc.l	0
fruit_active:	dc.l	-1
fruit_countdwn:	dc.l	7
fruit_x:		dc.l	0
fruit_y:		dc.l	0
jetpack_togo:	dc.l	3
jetpack_use:	dc.l	-1	
jetpack_next:	dc.l	-1	
jetpack_timer:	dc.l	-1	
jetpack_frame:	dc.l	0
				
new_fruit:		sub.l	#1,fruit_countdwn			; time for a new fruit?
				bpl		.no_fruit					; no, then we're done
				move.l	#7,fruit_countdwn			; next fruit in 8 platforms
				move.l	#1,fruit_active				; this one is active
				move.l	#24,fruit_x					; lowest X position
				
				move.w	ticks,d7					; get a random number (0-65535)
				and.w	#$ff,d7						; make it a byte (0-255)
				add.w	d7,fruit_x+2				; add to 24 for middle of screen
				
				move.l	#255+74,fruit_y				; fruity is off the bottom of screen
								
				tst.l	jetpack_next				; next fruit a jetpack?
				bmi.s	.normal						; no, then we're done
				
				move.l	#-1,jetpack_next			; next fruit is a jetpack!

				subq.l	#1,.which_bonus
				bpl.s	.no_bonwrap
				move.l	#2,.which_bonus
.no_bonwrap:	move.l	.which_bonus,d0
				add.l	#9,d0
				move.l	d0,fruit_next				; its the 10th gfx!
				rts

.which_bonus:	dc.l	0
				
.normal:		move.l	wall_random,d0				; get a rnd number
				and.l	#$ffff,d0					; make it a word
				divu	#9,d0						; divide by 9 (+0 = 10 points of division)
				swap.w	d0							; get remainder (0-8, or 9 variations)
				and.l	#$ffff,d0
				move.l	d0,fruit_next				; thats our fruit! (Or poulpe)

.no_fruit:		rts
				
process_fruit:	tst.l	fruit_active				; any fruits to place on screen?
				bmi		.no_fruit_today				; no, we're done

				sub.l	#1,fruit_y					; drag it up the screen
				bne.s	.fruity_ok					; reached the top?
							
				move.l	#-1,fruit_active			; yes, kill the fruit
				move.l	#400,fruit_y				; and move it offscreen

.fruity_ok:		move.l	fruit_y,d7					; get fruit y
				move.l	player_y,d5					; get player y
				
				sub.l	d7,d5						; subtract for difference
				bpl.s	.notnegy					; was result negative?
				neg.l	d5							; if so, make it positive
.notnegy:		cmp.l	#8,d5						; 8 pixels difference?
				bgt		.not_on_same				; nope, not on same y line then
				
				move.l	fruit_x,d6					; now do the same for 'X'
				move.l	player_x,d4
			
				sub.l	d6,d4
				bpl.s	.notnegx
				neg.l	d4
.notnegx:		cmp.l	#8,d4
				bgt		.not_on_same				; nope, didn't collect it

.pickup_fruit:	move.l	#-1,fruit_active			; we got it, mark it as done
				move.l	#400,fruit_y				; and move offscreen

				move.l	mapset,d6
.multiloop:		add.l	#100,total_dist				; add one hundred!				
				lea		dist_ascii+5,a0				; update the score
				bsr		add_100
				dbra	d6,.multiloop
				
				lea		dist_ascii,a0				; and re-draw it
				lea		score_jag,a1
				moveq	#7,d7
				bsr		do_numerals		

				cmp.l	#10,fruit_next				; jump boots?
				beq		.got_jump
				
				cmp.l	#11,fruit_next				; parachute?
				beq		.got_parachute
				
				cmp.l	#8,fruit_next				; was it a poulpe?
				beq		.got_poulpe
				
				cmp.l	#9,fruit_next				; was it jetpack?
				bne		.gotfruit					; no

.got_jetpack:	move.l	#-1,jumping_timer			; disable jumping
				move.l	#-1,para_timer				; disable parachute
				move.l	#1,jetpack_use				; set jetpack active
				move.l	#30*60,jetpack_timer		; and set timer

				eor.l	#1,jetp_sample
				move.l	jetp_sample,d1
				asl.w	#2,d1
				lea		jetpak_samples,a0
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#1,d7
				bsr		do_sample
				bra		.nofruitsam

.got_jump:		clr.l	fruit_next
				move.l	#-1,para_timer				; disable parachute
				move.l	#-1,jetpack_timer			; disable jetpack
				move.l	#30*60,jumping_timer
				sub.l	#1,jumpp_sample
				bpl.s	.shoe_ok
				move.l	#2,jumpp_sample
.shoe_ok:		move.l	jumpp_sample,d1
				asl.w	#2,d1
				lea		shoe_samples,a0
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#1,d7
				bsr		do_sample
				bra		.nofruitsam

.got_parachute:	clr.l	fruit_next
				move.l	#-1,jetpack_timer			; disable jetpack
				move.l	#-1,jumping_timer			; disable jumping
				move.l	#30*60,para_timer
				eor.l	#1,parap_sample
				move.l	parap_sample,d1
				asl.w	#2,d1
				lea		para_samples,a0
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#1,d7
				bsr		do_sample
				bra		.nofruitsam

.got_poulpe:	eor.l	#1,poulpe_sample
				move.l	poulpe_sample,d1
				asl.w	#2,d1
				lea		poulpe_samples,a0
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#1,d7
				bsr		do_sample
				bra		.nofruitsam
				
.gotfruit:		sub.l	#1,fruit_sample
				bpl.s	.playit
				move.l	#4,fruit_sample
.playit:		move.l	fruit_sample,d1
				asl.w	#2,d1
				lea		fruity_samples,a0
				move.l	4(a0,d1.w),d0				; end address
				move.l	(a0,d1.w),a0				; start address
				sub.l	a0,d0						; d0=length
				moveq	#1,d7
				bsr		do_sample
				
.nofruitsam:	sub.l	#1,jetpack_togo				; jetpack every 4th fruit
				bpl.s	.not_on_same				; after its been enabled
				move.l	#3,jetpack_togo				; reset, you missed it!
				move.l	#1,jetpack_next
				
.not_on_same:	move.l	fruit_obj,a0				; fruit object
				move.l	fruit_x,d0					; x
				move.l	fruit_y,d1					; y
					
				move.l	fruit_next,d2				; fruit number (0-8)
				asl.l	#4,d2						; *512 
				asl.l	#5,d2
				add.l	#fruit_jag,d2				; add to gfx base
				bsr		setup_object_xyg			; and draw it!
				
.no_fruit_today:
				rts
				
;;
;; call sample player
;;

;; Sample types:
;;
;; D7=0		= random chatter
;; D7=1		= pickup
;; D7=2		= pickup expiring
;; D7=3		= *ALWAYS* (Override repeat delay)
;;
;; highest priority sample will play, else return nothing
;;

current_pri:	dc.l	0
sample_del:		dc.l	-1

do_sample:		cmp.l	current_pri,d7
				blt		.exit						; lower priority, exit
				bgt.s	.play						; higher priority - always play
				
				tst.l	sample_del					; same priority, check if sample still playing
				bpl		.exit						; if so, exit

.play:			move.l	d7,current_pri				; save current priority
				
				move.l	d0,-(a7)
				moveq	#5,d0
				moveq	#4,d1
				jsr		musicplayer+$10				; clear all samples playing
				move.l	(a7)+,d0
				
				move.l	#60*3,sample_del			; delay till next sample allowed
				
				moveq	#0,d1						; and play the sample
				moveq	#2,d2
				moveq	#70,d3
				moveq	#0,d4
				move.l	d4,a1
				jmp		musicplayer+$c
.exit:			rts

;;
;; Background scrolling
;;				
				
background:		tst.l	background_flag				; is background scrolling?
				bmi		.noscrolling				; nope, so skip all this
				
				tst.l	_25hz						; 25hz toggle?
				bpl.s	.paramok
				sub.l	#72,param_off				; ok, do the far back
				bpl.s	.paramok
				add.l	#336*72,param_off			; wrapped?
.paramok:

				sub.l	#48*2,para4_off				; repeat for all 4 layers
				bpl.s	.para4ok
				add.l	#336*48,para4_off			; if wrapped, reset bitmap pointer
.para4ok:

				sub.l	#32*3,para3_off
				bpl.s	.para3ok
				add.l	#336*32,para3_off
.para3ok:

				sub.l	#24*4,para2_off
				bpl.s	.para2ok
				add.l	#336*24,para2_off
.para2ok:

				sub.l	#16*5,para1_off
				bpl.s	.para1ok
				add.l	#336*16,para1_off
.para1ok:

.noscrolling:	move.l	param_obj,a0				; and now, update all the objects
				move.l	#160-72,d0
				move.l	#16,d1
				move.l	#param_jag2,d2
				sub.l	param_off,d2
				bsr		setup_object_xyg
				
				move.l	para4a_obj,a0
				move.l	#50,d0
				move.l	#16,d1
				move.l	#para4_jag2,d2
				sub.l	para4_off,d2
				bsr		setup_object_xyg
				
				move.l	para4b_obj,a0
				move.l	#320-50,d0
				move.l	#16,d1
				move.l	#para4_jag2,d2
				sub.l	para4_off,d2
				bsr		setup_object_xyg
				
				move.l	para3a_obj,a0
				move.l	#30,d0
				move.l	#16,d1
				move.l	#para3_jag2,d2
				sub.l	para3_off,d2
				bsr		setup_object_xyg
				
				move.l	para3b_obj,a0
				move.l	#320-30,d0
				move.l	#16,d1
				move.l	#para3_jag2,d2
				sub.l	para3_off,d2
				bsr		setup_object_xyg
							
				move.l	para2a_obj,a0
				move.l	#10,d0
				move.l	#16,d1
				move.l	#para2_jag2,d2
				sub.l	para2_off,d2
				bsr		setup_object_xyg
				
				move.l	para2b_obj,a0
				move.l	#320-10,d0
				move.l	#16,d1
				move.l	#para2_jag2,d2
				sub.l	para2_off,d2
				bsr		setup_object_xyg

				move.l	para1a_obj,a0
				move.l	#0,d0
				move.l	#16,d1
				move.l	#para1_jag2,d2
				sub.l	para1_off,d2
				bsr		setup_object_xyg
				
				move.l	para1b_obj,a0
				move.l	#320,d0
				move.l	#16,d1
				move.l	#para1_jag2,d2
				sub.l	para1_off,d2
				bsr		setup_object_xyg
				
				rts

slide_offset:	dc.l	0				
param_off:		dc.l	0
para1_off:		dc.l	0
para2_off:		dc.l	0
para3_off:		dc.l	0
para4_off:		dc.l	0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Update Panels
;;
;;

score_delay:	dc.l	0							; delay till next score update

do_panels:		sub.l	#1,score_delay				; time to update?
				bpl		.noscore					; no, we're done
				move.l	#9,score_delay				; next update in 10 frames

				add.l	#1,total_dist				; add one!
				lea		dist_ascii+7,a0				; and add one to ascii!
				bsr		add_1

				tst.l	highscore					; highscore?
				bmi		.add_highscore				; yes, so skip
				
				move.l	total_dist,d0			
				cmp.l	high_dist,d0				; score>highscore?
				ble		.no_highscore				; nope, so skip over

				move.l	#-1,highscore
				move.l	#yippie,a0					; Yippie K!
				move.l	#yippie_end-yippie,d0
				moveq	#3,d7
				bsr		do_sample				

.add_highscore:	move.l	total_dist,high_dist		; move score to highscore
				move.l	dist_ascii,high_ascii
				move.l	dist_ascii+4,high_ascii+4
				
.no_highscore:				
				lea		dist_ascii,a0				; now update the bitmap
				lea		score_jag,a1
				moveq	#7,d7
				bsr		do_numerals

				lea		high_ascii,a0				; now update the bitmap
				lea		high_jag,a1
				moveq	#7,d7
				bsr		do_numerals
				bsr		replace_highscore			; align highscore
				
.noscore:		rts

replace_highscore:
				moveq	#8,d1						; 8 chars in score
				move.l	#20,d0						; x-position of leftmost digit
				sub.l	d6,d1						; 8-d6 = 8-chars in score
				asl.l	#4,d1						; number of digits *16
				sub.l	d1,d0						; calc x-position
				move.l	high_obj,a0					; put the highscore onscreen
				move.l	#20,d1
				jsr		setup_object_xy				
				rts
				
;;
;; returns D6=number of digits drawn
;;
			
do_numerals:	moveq	#-1,d6						; leading zero flag
				lea		font16_jag,a6				; address to draw score
.loop:			moveq	#0,d0
				move.b	(a0)+,d0					; get numeral
				sub.b	#'0',d0						; convert to HEX	

				bne		.normal						; non zero - normal!
				
				tst.l	d7							; last digit?
				beq		.normal						; must draw it
				
				tst.l	d6							; leading zero?
				bmi		.zero
		
.normal:		addq.l	#1,d6						; digit counter
				asl.w	#3,d0						; *16 (offset into font)
				move.l	a6,a2
				add.l	d0,a2
				move.l	(a2),(a1)					; and copy a 16x16 pixel block
				move.l	4(a2),4(a1)
				move.l	80(a2),80(a1)
				move.l	84(a2),84(a1)
				move.l	160(a2),160(a1)
				move.l	164(a2),164(a1)
				move.l	240(a2),240(a1)
				move.l	244(a2),244(a1)
				move.l	320(a2),320(a1)
				move.l	324(a2),324(a1)
				move.l	400(a2),400(a1)
				move.l	404(a2),404(a1)
				move.l	480(a2),480(a1)
				move.l	484(a2),484(a1)
				move.l	560(a2),560(a1)
				move.l	564(a2),564(a1)
				move.l	640(a2),640(a1)
				move.l	644(a2),644(a1)
				move.l	720(a2),720(a1)
				move.l	724(a2),724(a1)
				move.l	800(a2),800(a1)
				move.l	804(a2),804(a1)
				move.l	880(a2),880(a1)
				move.l	884(a2),884(a1)
				move.l	960(a2),960(a1)
				move.l	964(a2),964(a1)
				move.l	1040(a2),1040(a1)
				move.l	1044(a2),1044(a1)
				move.l	1120(a2),1120(a1)
				move.l	1124(a2),1124(a1)
				move.l	1200(a2),1200(a1)
				move.l	1204(a2),1204(a1)
.zero:			lea		8(a1),a1
				dbra	d7,.loop
				rts
				
add_1:			moveq	#7,d7						; 8 digits
.loop:			move.b	(a0),d0						; get digit
				add.b	#1,d0						; add one
				cmp.b	#'9'+1,d0					; wrapped?
				bne.s	.out						; no, we're done
				move.b	#'0',(a0)					; reset to zero
				subq.l	#1,a0						; move 1 digit left
				dbra	d7,.loop					; and check again
.out:			move.b	d0,(a0)						; output byte
				rts

add_100:		moveq	#5,d7						; same as above, 
.loop:			move.b	(a0),d0						; but starting in 5th column
				add.b	#1,d0						; so, adding 100
				cmp.b	#'9'+1,d0
				bne.s	.out
				move.b	#'0',(a0)
				subq.l	#1,a0
				dbra	d7,.loop
.out:			move.b	d0,(a0)
				rts
				
		
				dc.b "00"
dist_ascii:		dc.b "00000000"
total_dist:		dc.l 0

high_ascii:		dc.b "00001000"
high_dist:		dc.l 1000

highscore:		dc.l 1
	
;;;;
;;;; SET new object list
;;;;

set_game_list:	move.l	skip_obj,a0					; branch to titles
				lea		obj_copy1,a1
				movem.l	(a1),d0-d7
				movem.l	d0-d7,(a0)
				rts

set_title_list:	move.l	skip_obj,a0
				move.l	title_list,a1
				move.l	#braobject,d0
				move.l	#always,d1
				move.l	#$7ff,d2
				bsr		CreateObject
				rts

set_blank_list:	move.l	skip_obj,a0
				move.l	blank_list,a1
				move.l	#braobject,d0
				move.l	#always,d1
				move.l	#$7ff,d2
				bsr		CreateObject
				rts
				
				
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position and bitmap in d2
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
;; d2=bitmap address
;;
	

setup_object_xyg: 
		add.l	#16,d0
		add.l	#8,d1

				move.l	#%1111111111,d3
				tst.w	ntsc_flag
				bpl		.pal_skip
				add.w	#28,d1
.pal_skip:		and.w	#%111111111111,d0			; mask x value only (for negatives)
				and.w	d3,d1
				move.w  6(a0),d4                	; get y-pos
				and.w   #$c007,d4
				move.w  14(a0),d6               	; get x-pos
				and.w   #$f000,d6
				lsl.w	#4,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)					; update in object data
                move.w  d6,14(a0)
				lsl.l	#8,d2
				move.l	(a0),d0
				and.l 	d3,d0
				or.l	d2,d0
				move.l	d0,(a0)						; update object GFX pointer
				rts

				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
				
setup_object_xy:
		add.l	#16,d0
		add.l	#8,d1

				tst.w	ntsc_flag
				bpl		.pal_skip
				add.w	#28,d1
.pal_skip:		and.w	#%111111111111,d0
				and.w	#%1111111111,d1
				move.w  6(a0),d4                	; get y-pos
                and.w   #$c007,d4
                move.w  14(a0),d6               	; get x-pos
                and.w   #$f000,d6
				lsl.w	#4,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)					; update in object data
                move.w  d6,14(a0)
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Wait for a VBL
;;



randomstart:	dc.l	0					; pointer to 32k of random shit

wait_frame:		move.w	d7,-(a7)
 
				move.w  ticks,d7
.wait:          cmp.w   ticks,d7
                beq.s   .wait

				move.w	(a7)+,d7
                rts

				.phrase
rndcounter:		dc.w	0	
				.phrase
random:			dc.w	0
				.phrase
random2:		dc.w	0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Vertical Blank Interupt (At least it happens every frame somewhere......)
;;

				.phrase
VB_INTERUPT:    movem.l d0-d7/a0-a6,-(a7)
				
				jsr     copy_olist              	; use Blitter to update active list from shadow
            	add.w	#7,ticks
				neg.l	_25hz						; flip 25hz flag

				tst.l	sample_del
				bmi.s	.nodec
				subq.l	#1,sample_del
				bpl.s	.nodec
				move.l	#-1,current_pri
.nodec:
				
				move.l	wall_random,d0
				add.l	#3,d0
				ror.l	d0,d0
				move.l	d0,wall_random
				and.l	#%11111,d0
				move.l	d0,wall_rnd
				
				bsr		background
				jsr		musicplayer+8
				
				move.w  #$101,INT1              	; Signal we're done
                move.w  #$0,INT2

.exit:			
				movem.l (a7)+,d0-d7/a0-a6
                rte

				.dphrase
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Clear ram routine
;;

clear_memory:	clr.b	(a0)+
				cmp.l	a0,a1
				bne.s	clear_memory
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy ram routine
;;

copy_ram:       move.w (a0)+,(a2)+
                cmp.l a0,a1
                bne.s copy_ram
                rts

;;
;; call with D0=pattern to jump to
;;
				
change_pattern:	move.l			d0,-(a7)

				moveq			#1,d0					; clear all MOD channels
				moveq			#3,d1
				jsr				musicplayer+$10

                lea             vars_space(pc),a6
				lsl.w           #4,d0 
                move.l          d0,pattern_pos-vars_space(a6)
                move.b          #0,break_pos-vars_space(a6)
                move.b          #0,pos_jump_flag-vars_space(a6)
                moveq           #0,d0
				move.l			(a7)+,d0
                move.l          patt_pos_pntr-vars_space(a6),a0
				and.w           #$7f,d0
                move.b          d0,song_pos-vars_space(a6)
                move.b          0(a0,d0.w),d0
                lsl.l           #8,d0
                lsl.l           #2,d0
                add.l           patt_data_pntr-vars_space(a6),d0
                move.l          d0,song_data_pntr-vars_space(a6)
				rts						
				
				include "_CREDS.S"
				include "_initvid.s"
				include "_makeol.s"
				include "_joypad.s"
				include "_BMPCONV.S"
				include "_INITGFX.S"
				include "_AUDIO.S"
				include "_MEMTRCK.S"
				
rotary_mode:	dc.w	-1
turn_direction:	dc.w	0

fruity_samples:	dc.l	fruitsam1,fruitsam2,fruitsam3,fruitsam4,fruitsam5,fruitsam_end
jetpak_samples:	dc.l	jetpsam1,jetpsam2,banko
shoe_samples:	dc.l	shoesam1,shoesam2,shoesam3,shoesam_end
para_samples:	dc.l	para_sam1,para_sam2,para_end
poulpe_samples:	dc.l	poulpesam1,poulpesam2,poulpesam_end
random_samples:	dc.l	random_1,random_2,random_3,random_4
				dc.l	random_5,random_6,random_7,random_8
				dc.l	random_9,random_a,random_b,random_c
				dc.l	random_end

tileset_list:	dc.l	wall1_jag,wall2_jag,wall3_jag,wall4_jag,wall5_jag,wall6_jag,wall7_jag,wall8_jag
mapset_list:	dc.l	plat1_jag,plat2_jag,plat3_jag,plat4_jag,plat5_jag,plat6_jag,plat7_jag,plat8_jag

player_bmp:		incbin	"GFX/MAN_WALK.BMP"
playerjet_bmp:	incbin	"GFX/MAN_JET.BMP"
playerfall_bmp:	incbin	"GFX/MAN_FALL.BMP"
reboot_bmp:		incbin	"GFX/REBOOT.BMP"

wall1_bmp:		incbin	"WALLTILE/BLOCK1.BMP"
wall2_bmp:		incbin	"WALLTILE/BLOCK2.BMP"
wall3_bmp:		incbin	"WALLTILE/BLOCK3.BMP"
wall4_bmp:		incbin	"WALLTILE/BLOCK4.BMP"
wall5_bmp:		incbin	"WALLTILE/BLOCK5.BMP"
wall6_bmp:		incbin	"WALLTILE/BLOCK6.BMP"
wall7_bmp:		incbin	"WALLTILE/BLOCK7.BMP"
wall8_bmp:		incbin	"WALLTILE/BLOCK8.BMP"

plat1_bmp:		incbin	"WALLTILE/PLATa.bmp"
plat2_bmp:		incbin	"WALLTILE/PLATb.bmp"
plat3_bmp:		incbin	"WALLTILE/PLATc.bmp"
plat4_bmp:		incbin	"WALLTILE/PLATd.bmp"
plat5_bmp:		incbin	"WALLTILE/PLATe.bmp"
plat6_bmp:		incbin	"WALLTILE/PLATf.bmp"
plat7_bmp:		incbin	"WALLTILE/PLATg.bmp"
plat8_bmp:		incbin	"WALLTILE/PLATh.bmp"

fullfont_bmp:	incbin	"GFX/VFONT.BMP"

fruit_bmp:		incbin	"GFX/FRUIT.BMP"
poulpe_bmp:		incbin 	"GFX/POULPE.BMP"
jetpack_bmp:	incbin	"GFX/JETPACK.BMP"
shoe_bmp:		incbin	"GFX/SHOE.BMP"
para_bmp:		incbin	"GFX/BALLOON.BMP"
logo_bmp:		incbin	"GFX/DOWNFALL.BMP"
font16_bmp:		incbin	"GFX/FONT16.BMP"

para1_bmp:		incbin	"CAVEWALL/PARA1.BMP"
para2_bmp:		incbin	"CAVEWALL/PARA2.BMP"
para3_bmp:		incbin	"CAVEWALL/PARA3.BMP"
para4_bmp:		incbin	"CAVEWALL/PARA4.BMP"
param_bmp:		incbin	"CAVEWALL/PARAM.BMP"

music:			incbin	"MUSIC/LG_WINGZ.MOD"

fruitsam1:		incbin	"SAMPLES/FRUIT1.RAW"
fruitsam2:		incbin	"SAMPLES/FRUIT2.RAW"
fruitsam3:		incbin	"SAMPLES/FRUIT3.RAW"
fruitsam4:		incbin	"SAMPLES/FRUIT4.RAW"
fruitsam5:		incbin	"SAMPLES/FRUIT5.RAW"
fruitsam_end:

jetpsam1:		incbin	"SAMPLES/JETPACK1.RAW"
jetpsam2:		incbin	"SAMPLES/JETPACK2.RAW"
banko:			incbin	"SAMPLES/ENDJPACK.RAW"
banko_end:

shoesam1:		incbin	"SAMPLES/SHOES.RAW"
shoesam2:		incbin	"SAMPLES/SPRINGY.RAW"
shoesam3:		incbin	"SAMPLES/CLOWNSHO.RAW"
shoesam_end:

poulpesam1:		incbin 	"SAMPLES/POULPES.RAW"
poulpesam2:		incbin	"SAMPLES/WRONGAME.RAW"
poulpesam_end:

para_sam1:		incbin	"SAMPLES/FALLING.RAW"
para_sam2:		incbin	"SAMPLES/JERONIM.RAW"
para_end:

downfall:		incbin	"SAMPLES/DOWNFALL.RAW"
downfall_end:	

yippie:			incbin	"SAMPLES/YIPPIE.RAW"
yippie_end:

gameover_sam:	incbin	"SAMPLES/GAMEOVER.RAW"
gameover_end:	

reboot_sam:		incbin	"SAMPLES/REBOOT.RAW"
reboot_end:

random_1:		incbin	"SAMPLES/RANDOM1.RAW"
random_2:		incbin	"SAMPLES/RANDOM2.RAW"
random_3:		incbin	"SAMPLES/RANDOM3.RAW"
random_4:		incbin	"SAMPLES/RANDOM4.RAW"
random_5:		incbin	"SAMPLES/RANDOM5.RAW"
random_6:		incbin	"SAMPLES/RANDOM6.RAW"
random_7:		incbin	"SAMPLES/RANDOM7.RAW"
random_8:		incbin	"SAMPLES/RANDOM8.RAW"
random_9:		incbin	"SAMPLES/RANDOM9.RAW"
random_a:		incbin	"SAMPLES/RANDOMA.RAW"
random_b:		incbin	"SAMPLES/RANDOMB.RAW"
random_c:		incbin	"SAMPLES/RANDOMC.RAW"
random_end:

illegal_sam:	incbin	"SAMPLES/ILLEGAL.RAW"
illegal_end:

				.bss
						.dphrase
top_of_bss:
						.phrase

blank_list:				.ds.l	1
title_list:				.ds.l	1
skip_obj:				.ds.l	1
obj_copy1:				.ds.l	8
player_obj:				.ds.l	1
parachute_obj:			.ds.l	1
screen_obj:				.ds.l	1
logo_obj:				.ds.l	1
textblock_obj:			.ds.l	1
score_obj:				.ds.l	1
high_obj:				.ds.l	1
title_obj:				.ds.l	1
blocking_obj:			.ds.l	1
fruit_obj:				.ds.l	1
para1a_obj:				.ds.l	1
para1b_obj:				.ds.l	1
para2a_obj:				.ds.l	1
para2b_obj:				.ds.l	1
para3a_obj:				.ds.l	1
para3b_obj:				.ds.l	1
para4a_obj:				.ds.l	1
para4b_obj:				.ds.l	1
param_obj:				.ds.l	1

player_x_adder:			.ds.l	1
player_y_adder:			.ds.l	1
_25hz:					.ds.l	1

background_flag:		.ds.l	1

player_x:				.ds.l	1
						.ds.l	1
player_y:				.ds.l	1
						.ds.l	1
player_frame:			.ds.l	1
anim_delay:				.ds.l	1
direction:				.ds.l	1
at_stop:				.ds.l	1
falling:				.ds.l	1
falling_anim:			.ds.l	1
falling_offset:			.ds.l	1

ntsc_flag:				.ds.w	1
a_hdb:          		.ds.w   1
a_hde:          		.ds.w   1
a_vdb:          		.ds.w   1
a_vde:          		.ds.w   1
width:          		.ds.w   1
height:         		.ds.w   1
ticks:					.ds.w	1
temppal:				.ds.w	256

						.dphrase
memory_track_work:		.ds.b	16384						
player_jag:				.ds.b	32*16*8
playerjet_jag:			.ds.b	32*16*4
playerfall_jag:			.ds.b	32*16*2

logo_jag:				.ds.b	640*80
fullfont_jag:			.ds.b	8*928
						.ds.b	8*16
textblock_jag:			.ds.b	160*64
para1_jag:				.ds.b	16*336
para1_jag2:				.ds.b	16*336
para2_jag:				.ds.b	24*336
para2_jag2:				.ds.b	24*336
para3_jag:				.ds.b	32*336
para3_jag2:				.ds.b	32*336
para4_jag:				.ds.b	48*336
para4_jag2:				.ds.b	48*336
param_jag:				.ds.b	72*336
param_jag2:				.ds.b	72*336
blocking_jag:			.ds.b	40*16
wall0_jag:				.ds.b	640*8
wall1_jag:				.ds.b	64*8
wall2_jag:				.ds.b	64*8
wall3_jag:				.ds.b	64*8
wall4_jag:				.ds.b	64*8
wall5_jag:				.ds.b	64*8
wall6_jag:				.ds.b	64*8
wall7_jag:				.ds.b	64*8
wall8_jag:				.ds.b	64*8
plat1_jag:				.ds.b	20*32
plat2_jag:				.ds.b	20*32
plat3_jag:				.ds.b	20*32
plat4_jag:				.ds.b	20*32
plat5_jag:				.ds.b	20*32
plat6_jag:				.ds.b	20*32
plat7_jag:				.ds.b	20*32
plat8_jag:				.ds.b	20*32
font16_jag:				.ds.b	80*16
fruit_jag:				.ds.b	32*(16*12)	; 8 fruit, 1 poulpe, 1 jetpack, 1 shoe, 1 parachute
score_jag:				.ds.b	80*16
high_jag:				.ds.b	80*16
para1_pal:				.ds.b	32
para2_pal:				.ds.b	32
para3_pal:				.ds.b	32
para4_pal:				.ds.b	32
param_pal:				.ds.b	32
font16_pal:				.ds.b	32
black_pal:				.ds.b	32
font_pal:				.ds.b	32

						.dphrase
						.ds.b	640
screen:					.ds.b	640*256*2
						.phrase

				.dphrase
_trashram:		
				.end

				
				
				